/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.SensorrepeticaoRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Sensorrepeticao extends TableImpl<SensorrepeticaoRecord> {

    private static final long serialVersionUID = -676778517;

    /**
     * The reference instance of <code>public.sensorrepeticao</code>
     */
    public static final Sensorrepeticao SENSORREPETICAO = new Sensorrepeticao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<SensorrepeticaoRecord> getRecordType() {
        return SensorrepeticaoRecord.class;
    }

    /**
     * The column <code>public.sensorrepeticao.senrepid</code>.
     */
    public final TableField<SensorrepeticaoRecord, Integer> SENREPID = createField("senrepid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('sensorrepeticao_senrepid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.sensorrepeticao.fktiprepid</code>.
     */
    public final TableField<SensorrepeticaoRecord, Integer> FKTIPREPID = createField("fktiprepid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.sensorrepeticao.fksenid</code>.
     */
    public final TableField<SensorrepeticaoRecord, Integer> FKSENID = createField("fksenid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.sensorrepeticao</code> table reference
     */
    public Sensorrepeticao() {
        this(DSL.name("sensorrepeticao"), null);
    }

    /**
     * Create an aliased <code>public.sensorrepeticao</code> table reference
     */
    public Sensorrepeticao(String alias) {
        this(DSL.name(alias), SENSORREPETICAO);
    }

    /**
     * Create an aliased <code>public.sensorrepeticao</code> table reference
     */
    public Sensorrepeticao(Name alias) {
        this(alias, SENSORREPETICAO);
    }

    private Sensorrepeticao(Name alias, Table<SensorrepeticaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Sensorrepeticao(Name alias, Table<SensorrepeticaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.SENSORREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<SensorrepeticaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_SENSORREPETICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<SensorrepeticaoRecord> getPrimaryKey() {
        return Keys.SENSORREPETICAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<SensorrepeticaoRecord>> getKeys() {
        return Arrays.<UniqueKey<SensorrepeticaoRecord>>asList(Keys.SENSORREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<SensorrepeticaoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<SensorrepeticaoRecord, ?>>asList(Keys.SENSORREPETICAO__SENSORREPETICAO_FKTIPREPID_FKEY, Keys.SENSORREPETICAO__SENSORREPETICAO_FKSENID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Sensorrepeticao as(String alias) {
        return new Sensorrepeticao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Sensorrepeticao as(Name alias) {
        return new Sensorrepeticao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Sensorrepeticao rename(String name) {
        return new Sensorrepeticao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Sensorrepeticao rename(Name name) {
        return new Sensorrepeticao(name, null);
    }
}
